CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC   
c                                                                  c
c   this routine is part of the software package                   c
c     ***  speedEVB ***                                            c
c                                                                  c
c   Copyright (C) 2007 Udo W. Schmitt                              c
c   Full copyright notice at                                       c
c   http://www.mpibpc.mpg.de/groups/grubmueller/uschmit1/copy.html c
c   Contact for info Udo W. Schmitt, MPI for biophysical chemistry,c 
C                     Goettingen, GERMANY                          c
c   Email:uschmit1@gwdg.de                                         c
c                                                                  c  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      PROGRAM rate

      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 POP(0:20000),T(1000000)
      REAL*8 x(1000000)
      LOGICAL flag
      NPISU = 1

      write(*,*) 'Reading TRAJECTORY file'

C open file unit 
      open(50,file="TRAJECTORY")
      DO I=1,1000000
       READ(50,*,END=200) T(I),X(I)
      END DO

200   NDATA = I - 1
      REWIND(50)

      DT = T(2)-T(1)

      write(*,*) 'Number of data points read:',NDATA
      write(*,*) 

      n_a = 0
      n_b = 0

      DO K=0,NPISU-1     
       DO I=1,NDATA
        READ(50+K*5,*,END=200) T(I),X(I)
        IF(x(I) .Lt. 0.0) THEN 
         n_a = n_a + 1
        ELSE
         n_b = n_b + 1
        ENDIF
       ENDDO
      ENDDO
      CLOSE(50)


      x_a = dble(n_a)/dble(ndata)
      x_b = dble(n_b)/dble(ndata)

      write(*,20) "equilibrium fraction x_a = ",x_a
      write(*,20) "equilibrium fraction x_b = ",x_b
      write(*,*) 

      N_WIND = 5
      NTEIL = 1

      n_ab = 0
      DO I=1,NDATA-1
       if(x(i).lt.0.0 .and. x(i+1).gt.0.0) then 
        flag = .true.
        do j=1,n_wind
         if(x(i+j).lt.0.0) flag = .false.
        enddo
        if(flag) n_ab = n_ab + 1
       endif
      END DO
      write(*,20) "rate by counting = ",
     *                    dble(n_ab)/(DT*NDATA)/x_a



      NAV = 0

      DO I=1,NDATA-N_WIND,1
        hH0 = 0.0
        IF(x(I) .Lt. 0.0) THEN 
         DO J=0,N_WIND-1
          IF(x(I+J) .Lt. 0.0) THEN
           POP(J) = POP(J) + (1.0-x_a)**2
          ENDIF
         ENDDO
        ENDIF
        NAV = NAV + 1
      END DO

20    format(A26,f16.6)

      END
